#
# (C) Tenable Network Security
#
if(description)
{
 script_id(13637);
 script_version("$Revision: 1.3 $");
 script_cve_id("CAN-2004-0213");
 name["english"] = "Utility Manager Could Allow Code Execution (842526)";

 script_name(english:name["english"]);

 desc["english"] = "
The remote host is running a version of the Utility Manager which contains
a flaw which may allow a local attacker to execute arbitrary code on the host,
thus escalating his privileges and obtaining the full control of the remote
system.

Solution : http://www.microsoft.com/technet/security/bulletin/ms04-019.mspx
Risk factor : High";

 script_description(english:desc["english"]);
 
 summary["english"] = "Checks for ms04-019 over the registry";

 script_summary(english:summary["english"]);
 
 script_category(ACT_GATHER_INFO);
 
 script_copyright(english:"This script is Copyright (C) 2004 Tenable Network Security");
 family["english"] = "Windows";
 script_family(english:family["english"]);
 
 script_dependencies("netbios_name_get.nasl", "smb_login.nasl", "smb_registry_full_access.nasl", "smb_reg_service_pack_W2K.nasl");
 script_require_keys("SMB/name", "SMB/login", "SMB/password",
		     "SMB/registry_full_access","SMB/WindowsVersion");


 script_require_ports(139, 445);
 exit(0);
}

include("smb_nt.inc");
port = get_kb_item("SMB/transport");
if(!port)port = 139;

access = get_kb_item("SMB/registry_access");
if(!access)exit(0);
key = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Hotfix\KB842526";
item = "Comments";
value = registry_get_sz(item:item, key:key);
if ( value ) exit(0);

access = get_kb_item("SMB/registry_full_access");
if(!access)exit(0);

version = get_kb_item("SMB/WindowsVersion");
if ( ! version || "5.0" >!< version  ) exit(0);

sp = get_kb_item("SMB/Win2K/ServicePack");
if(ereg(string:sp, pattern:"Service Pack [5-9]"))exit(0);


key = "SOFTWARE\Microsoft\Updates\Windows 2000\SP5\KB842526";
item = "Description";
value = registry_get_sz(item:item, key:key);
if ( ! value ) security_hole(port);

