#
# (C) Tenable Network Security
#
#
#

if(description)
{
 script_id(13642);
 script_version("$Revision: 1.1 $");
 script_cve_id("CAN-2004-0420");
 
 name["english"] = "Buffer overrun in Windows Shell (839645)";
 
 script_name(english:name["english"]);
 
 desc["english"] = "
The remote host is running a version of Windows which has a flaw in 
its shell. An attacker could persuade a user on the remote host to execute
a rogue program by using a CLSID instead of a file type, thus fooling
the user into thinking that he will not execute an application but simply
open a document.

Solution : http://www.microsoft.com/technet/security/bulletin/ms04-024.mspx
Risk factor : Medium";

 script_description(english:desc["english"]);
 
 summary["english"] = "Checks for ms04-024 over the registry";

 script_summary(english:summary["english"]);
 
 script_category(ACT_GATHER_INFO);
 
 script_copyright(english:"This script is Copyright (C) 2004 Tenable Network Security");
 family["english"] = "Windows";
 script_family(english:family["english"]);
 
 script_dependencies("netbios_name_get.nasl",
 		     "smb_login.nasl","smb_registry_full_access.nasl",
		     "smb_reg_service_pack_XP.nasl",
		     "smb_reg_service_pack_W2K.nasl");
 script_require_keys("SMB/name", "SMB/login", "SMB/password",
		     "SMB/registry_full_access","SMB/WindowsVersion");
 script_exclude_keys("SMB/Win2003/ServicePack");


 script_require_ports(139, 445);
 exit(0);
}

include("smb_nt.inc");
port = get_kb_item("SMB/transport");
if(!port)port = 139;


access = get_kb_item("SMB/registry_full_access");
if(!access)exit(0);

version = get_kb_item("SMB/WindowsVersion");
if ( ! version ) exit(0);

key = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Hotfix\KB839645";
item = "Comments";
value = registry_get_sz(item:item, key:key);
if ( value )  exit(0);

if("4.0" >< version)
{
 security_hole(port);
 exit(0);
}

if("5.0" >< version)
{
        sp = get_kb_item("SMB/Win2k/ServicePack");
        if(ereg(string:sp, pattern:"Service Pack [5-9]"))exit(0);
        key = "SOFTWARE\Microsoft\Updates\Windows 2000\SP5\KB839645";
        item = "Description";
        value = registry_get_sz(item:item, key:key);
        if ( ! value ) security_hole(port);
}



if("5.1" >< version)
{
        key[0] = "SOFTWARE\Microsoft\Updates\Windows XP\SP1\KB839645";
        key[1] = "SOFTWARE\Microsoft\Updates\Windows XP\SP2\KB839645";
        item = "Description";

        for (keyi=0; key[keyi]; keyi++)
        {
            value = registry_get_sz(item:item, key:key[keyi]);
            if ( value ) exit(0);
            value = NULL;
        }

        key[2] = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\HotFix\KB839645";
        item = "Comments";
        value = registry_get_sz(item:item, key:key[2]);
        if ( value ) exit(0);

        # Will be fixed in Service Pack 2
        sp = get_kb_item("SMB/WinXP/ServicePack");
        if(ereg(string:sp, pattern:"Service Pack [2-9]"))exit(0);

        security_hole(port);
	exit(0);
}

if("5.2" >< version)
{
        sp = get_kb_item("SMB/Win2003/ServicePack");
        if(ereg(string:sp, pattern:"Service Pack [1-9]"))exit(0);
        key = "SOFTWARE\Microsoft\Updates\Windows Server 2003\SP1\KB839645";
        item = "Description";
        value = registry_get_sz(item:item, key:key);
        if ( ! value ) security_hole(port);
}

