#
# This script was written by George A. Theall, <theall@tifaware.com>.
#
# See the Nessus Scripts License for details.
#

if (description) {
  script_id(12262);
  script_version ("$Revision: 1.3 $");

  script_bugtraq_id(10667);
 
  name["english"] = "Open WebMail Content-Type XSS Vulnerability";
  script_name(english:name["english"]);
 
  desc["english"] = "
The remote server is running Open WebMail version 2.32 or earlier which
is vulnerable to a cross site scripting attack whereby an attacker can
cause a victim to unknowingly run arbitrary Javascript code by reading a
MIME message with a specially crafted Content-Type or
Content-Description header. 

For more information, see :

  http://www.rs-labs.com/adv/RS-Labs-Advisory-2004-2.txt
  http://www.rs-labs.com/adv/RS-Labs-Advisory-2004-1.txt

Note : Nessus has determined the vulnerability exists on the target
simply by looking at the version number of Open WebMail installed there;
it has not attempted to actually exploit the vulnerability. 

Solution : Upgrade to Open WebMail version 2.32 20040603 or later.
Risk factor : Serious";
  script_description(english:desc["english"]);
 
  summary["english"] = "Checks for Content-Type XSS vulnerability in Open WebMail";
  script_summary(english:summary["english"]);
 
  script_category(ACT_GATHER_INFO);
  script_copyright(english:"This script is Copyright (C) 2004 George A. Theall");

  family["english"] = "CGI abuses";
  script_family(english:family["english"]);

  script_dependencie("openwebmail_detect.nasl", "cross_site_scripting.nasl");
  script_require_ports("Services/www", 80);

  exit(0);
}

include("http_func.inc");

port = get_http_port(default:80);
if (!get_port_state(port)) exit(0);

if(get_kb_item(string("www/", port, "/generic_xss"))) exit(0);

vers = get_kb_item(string("www/", port, "/openwebmail/version"));
if (!vers) exit(0);
if (ereg(pattern:"^(1|2\.(0|1|2|3[0-2]))$", string:vers)) security_hole(port);
