#
# (C) Tenable Network Security
#
if(description)
{
 script_id(12051);
 script_version("$Revision: 1.5 $");
 script_cve_id("CAN-2003-0825");
 script_bugtraq_id(9624);
 name["english"] = "WINS Buffer Overflow (830352)";
 
 script_name(english:name["english"]);
 
 desc["english"] = "
The remote Windows Internet Naming Service (WINS) is vulnerable to a 
flaw which could allow an attacker to execute arbitrary code on this host.

To exploit this flaw, an attacker would need to send a specially crafted
packet with improperly advertised lengths.

Solution : http://www.microsoft.com/technet/security/bulletin/ms04-006.mspx
Risk factor : Low (Windows NT, Windows 2000) / High (Windows 2003)";

 script_description(english:desc["english"]);
 
 summary["english"] = "Checks the version of MDAC";

 script_summary(english:summary["english"]);
 
 script_category(ACT_GATHER_INFO);
 
 script_copyright(english:"This script is Copyright (C) 2004 Tenable Network Security");
 family["english"] = "Windows";
 script_family(english:family["english"]);
 
 script_dependencies("netbios_name_get.nasl",
 		     "smb_login.nasl","smb_registry_full_access.nasl",
		     "smb_reg_service_pack_W2K.nasl");
 script_require_keys("SMB/name", "SMB/login", "SMB/password",
		     "SMB/registry_full_access","SMB/WindowsVersion");


 script_require_ports(139, 445);
 exit(0);
}

include("smb_nt.inc");
port = get_kb_item("SMB/transport");
if(!port)port = 139;


access = get_kb_item("SMB/registry_full_access");
if(!access)exit(0);

version = get_kb_item("SMB/WindowsVersion");

if ( ! version ) exit(0);

#check for server:
key = "SYSTEM\CurrentControlSet\Control\ProductOptions";
item = "ProductType";
value = registry_get_sz(key:key, item:item);
if (!(value == "LanmanNT") && !(value == "ServerNT")) exit (0);


if("4.0" >< version )
{
 key = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Hotfix\KB830352";
 item = "Comments";

 value = registry_get_sz(item:item, key:key);
 if(!value)security_warning(port);
}


if("5.0" >< version)
{
 key = "SOFTWARE\Microsoft\Updates\Windows 2000\SP5\KB830352";
 item = "Description";

# Will be fixed in Service Pack 5
 sp = get_kb_item("SMB/Win2K/ServicePack");
 if(ereg(string:sp, pattern:"Service Pack [5-9]"))exit(0);
  
 value = registry_get_sz(item:item, key:key);
 if(!value)security_warning(port);
}

if("5.2" >< version)
{
 key = "SOFTWARE\Microsoft\Updates\Windows Server 2003\SP1\KB830352";
 item = "Description";
# Will be fixed in Service Pack 1
 sp = get_kb_item("SMB/Win2003/ServicePack");
 if(ereg(string:sp, pattern:"Service Pack [1-9]"))exit(0);
 
 value = registry_get_sz(item:item, key:key);
 if(!value)security_hole(port);
}


