#
# (C) Tenable Network Security
#
if(description)
{
 script_id(12207);
 script_cve_id("CAN-2004-0197");
 
 script_version("$Revision: 1.3 $");

 name["english"] = "Microsoft Hotfix KB837001 (registry check)";

 script_name(english:name["english"]);

 desc["english"] = "
The remote host has a bug in its Microsoft Jet Database Engine (837001).

An attacker may exploit one of these flaws to execute arbitrary code on the
remote system.

To exploit this flaw, an attacker would need the ability to craft a specially
malformed database query and have this engine execute it.

Solution : http://www.microsoft.com/technet/security/bulletin/ms04-014.mspx
Risk factor : High";

 script_description(english:desc["english"]);
 
 summary["english"] = "Checks for ms04-014";

 script_summary(english:summary["english"]);
 
 script_category(ACT_GATHER_INFO);
 
 script_copyright(english:"This script is Copyright (C) 2004 Tenable Network Security");
 family["english"] = "Windows";
 script_family(english:family["english"]);
 
 script_dependencies("netbios_name_get.nasl",
 		     "smb_login.nasl","smb_registry_full_access.nasl",
		     "smb_reg_service_pack_W2K.nasl",
		     "smb_reg_service_pack_XP.nasl");
 script_require_keys("SMB/name", "SMB/login", "SMB/password",
		     "SMB/registry_full_access","SMB/WindowsVersion");


 script_require_ports(139, 445);
 exit(0);
}

include("smb_nt.inc");
port = get_kb_item("SMB/transport");
if(!port)port = 139;


access = get_kb_item("SMB/registry_full_access");
if(!access)exit(0);

version = get_kb_item("SMB/WindowsVersion");

if ( ! version ) exit(0);


if("4.0" >< version )
{
 key = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Hotfix\KB837001";
 item = "Comments";

 value = registry_get_sz(item:item, key:key);
 if(!value)security_hole(port);
}


if("5.0" >< version)
{
 key = "SOFTWARE\Microsoft\Updates\Windows 2000\SP5\KB837001";
 item = "Description";

# Will be fixed in Service Pack 5
 sp = get_kb_item("SMB/Win2K/ServicePack");
 if(ereg(string:sp, pattern:"Service Pack [5-9]"))exit(0);
  
 value = registry_get_sz(item:item, key:key);
 if(!value)security_hole(port);
}

if("5.1" >< version)
{
 key = "SOFTWARE\Microsoft\Updates\Windows XP\SP1\KB837001";
 item = "Description";

  
 value = registry_get_sz(item:item, key:key);
 if(!value){
 key = "SOFTWARE\Microsoft\Updates\Windows XP\SP2\KB837001";
 value = registry_get_sz(item:item, key:key);
 if ( value ) exit(0);
 }
 else exit(0);
	
# Will be fixed in Service Pack 2
 sp = get_kb_item("SMB/WinXP/ServicePack");
 if(ereg(string:sp, pattern:"Service Pack [2-9]"))exit(0);

 security_hole(port);
}

if("5.2" >< version)
{
 key = "SOFTWARE\Microsoft\Updates\Windows Server 2003\SP1\KB837001";
 item = "Description";
# Will be fixed in Service Pack 1
 sp = get_kb_item("SMB/Win2003/ServicePack");
 if(ereg(string:sp, pattern:"Service Pack [1-9]"))exit(0);
 
 value = registry_get_sz(item:item, key:key);
 if(!value)security_hole(port);
}
