#
# (C) Tenable Network Security
#
if(description)
{
 script_id(13643);
 script_version("$Revision: 1.1 $");
 script_cve_id("CAN-2004-0215");
 name["english"] = "Cumulative Security Update for Outlook Express (823353)";

 script_name(english:name["english"]);

 desc["english"] = "
The remote host is missing a cumulative security update for Outlook Express
which fixes a denial of service vulnerability in the Outlook Express mail
client.

To exploit this vulnerability, an attacker would need to send a malformed
message to a victim on the remote host. The message will crash her version
of Outlook, thus preventing her from reading her e-mail.

Solution : http://www.microsoft.com/technet/security/bulletin/ms04-018.mspx
Risk factor : Medium";

 script_description(english:desc["english"]);
 
 summary["english"] = "Checks for ms04-018 over the registry";

 script_summary(english:summary["english"]);
 
 script_category(ACT_GATHER_INFO);
 
 script_copyright(english:"This script is Copyright (C) 2004 Tenable Network Security");
 family["english"] = "Windows";
 script_family(english:family["english"]);
 
 script_dependencies("netbios_name_get.nasl", "smb_login.nasl", "smb_registry_full_access.nasl", "smb_reg_service_pack_W2K.nasl");
 script_require_keys("SMB/name", "SMB/login", "SMB/password",
		     "SMB/registry_full_access","SMB/WindowsVersion");


 script_require_ports(139, 445);
 exit(0);
}

include("smb_nt.inc");
port = get_kb_item("SMB/transport");
if(!port)port = 139;

access = get_kb_item("SMB/registry_full_access");
if(!access)exit(0);

version = get_kb_item("SMB/WindowsVersion");
if ( ! version  ) exit(0);

key = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Hotfix\KB823353";
item = "Installed";
value = registry_get_dword(item:item, key:key);
if ( value ) exit(0);

key = "SOFTWARE\Microsoft\Active Setup\Installed Components\{F5173CF0-1DFB-4978-8E50-A90169EE7CA9}";
item = "IsInstalled";
value = registry_get_dword(item:item, key:key);
if ( value ) exit(0);
security_warning(port);
