#
# (C) Tenable Network Security
#
if(description)
{
 script_id(13640);
 script_version("$Revision: 1.1 $");
 script_cve_id("CAN-2004-0212");
 name["english"] = "Task Scheduler Vulnerability (841873)";

 script_name(english:name["english"]);

 desc["english"] = "
The remote host is running a version of Windows which contains a flaw in
the task scheduler which may lead to arbitrary execution of commands 
on the remote host.

To exploit this vulnerability, an attacker would need to lure a user on
the remote host to take certain steps to execute a .job file, or to visit
a rogue web site, then he may be able to execute arbitary commands on the 
remote host.

Solution : http://www.microsoft.com/technet/security/bulletin/ms04-022.mspx
Risk factor : High";

 script_description(english:desc["english"]);
 
 summary["english"] = "Checks for ms04-022 over the registry";

 script_summary(english:summary["english"]);
 
 script_category(ACT_GATHER_INFO);
 
 script_copyright(english:"This script is Copyright (C) 2004 Tenable Network Security");
 family["english"] = "Windows";
 script_family(english:family["english"]);
 
 script_dependencies("netbios_name_get.nasl", "smb_login.nasl", "smb_registry_full_access.nasl", "smb_reg_service_pack_W2K.nasl", "smb_reg_service_pack_XP.nasl");
 script_require_keys("SMB/name", "SMB/login", "SMB/password",
		     "SMB/registry_full_access","SMB/WindowsVersion");


 script_require_ports(139, 445);
 exit(0);
}

include("smb_nt.inc");
port = get_kb_item("SMB/transport");
if(!port)port = 139;


access = get_kb_item("SMB/registry_full_access");
if(!access)exit(0);
version = get_kb_item("SMB/WindowsVersion");

key = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Hotfix\KB841373";
item = "Comments";
value = registry_get_sz(item:item, key:key);
if ( value ) exit(0);

if ( "5.0" >< version )
{
 sp = get_kb_item("SMB/Win2K/ServicePack");
 if(ereg(string:sp, pattern:"Service Pack [5-9]"))exit(0);
 key = "SOFTWARE\Microsoft\Updates\Windows 2000\SP5\KB841873";
 item = "Description";
 value = registry_get_sz(item:item, key:key);
 if ( ! value ) security_hole(port);
 exit(0);
}

if ( "5.1" >< version )
{
 sp = get_kb_item("SMB/WinXP/ServicePack");
 if(ereg(string:sp, pattern:"Service Pack [2-9]"))exit(0);
 key = "SOFTWARE\Microsoft\Updates\Windows XP\SP2\KB841873";
 item = "Description";
 value = registry_get_sz(item:item, key:key);
 if ( ! value ) security_hole(port);
 exit(0);
}

