#
# (C) Tenable Network Security
#
if(description)
{
 script_id(13641);
 script_version("$Revision: 1.1 $");
 script_cve_id("CAN-2004-0201", "CAN-2003-1041");
 name["english"] = "Vulnerability in HTML Help Could Allow Code Execution (840315)";

 script_name(english:name["english"]);

 desc["english"] = "
The remote host is subject to two vulnerabilities in the HTML Help and showHelp
modules, which could allow an attacker to execute arbitrary code on the remote 
host.

To exploit this flaw, an attacker would need to set up a rogue website
containing a malicious showHelp URL, and would need to lure a user on the
remote host to visit it. Once the user visits the web site, a buffer overflow
would allow the attacker to execute arbitrary commands with the privileges
of the victim user.

Solution : http://www.microsoft.com/technet/security/bulletin/ms04-023.mspx
Risk factor : High";

 script_description(english:desc["english"]);
 
 summary["english"] = "Checks for ms04-023 over the registry";

 script_summary(english:summary["english"]);
 
 script_category(ACT_GATHER_INFO);
 
 script_copyright(english:"This script is Copyright (C) 2004 Tenable Network Security");
 family["english"] = "Windows";
 script_family(english:family["english"]);
 
 script_dependencies("netbios_name_get.nasl", "smb_login.nasl", "smb_registry_full_access.nasl", "smb_reg_service_pack_W2K.nasl", "smb_reg_service_pack_XP.nasl");
 script_require_keys("SMB/name", "SMB/login", "SMB/password",
		     "SMB/registry_full_access","SMB/WindowsVersion");


 script_require_ports(139, 445);
 exit(0);
}

include("smb_nt.inc");
port = get_kb_item("SMB/transport");
if(!port)port = 139;


access = get_kb_item("SMB/registry_full_access");
if(!access)exit(0);
version = get_kb_item("SMB/WindowsVersion");

key = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Hotfix\KB840315";
item = "Comments";
value = registry_get_sz(item:item, key:key);
if ( value ) exit(0);

if ("4.0" >< version ) 
{
 security_hole(port);
 exit(0);
}

if ( "5.0" >< version )
{
 sp = get_kb_item("SMB/Win2K/ServicePack");
 if(ereg(string:sp, pattern:"Service Pack [5-9]"))exit(0);
 key = "SOFTWARE\Microsoft\Updates\Windows 2000\SP5\KB840315";
 item = "Description";
 value = registry_get_sz(item:item, key:key);
 if ( ! value ) security_hole(port);
 exit(0);
}

if ( "5.1" >< version )
{
 sp = get_kb_item("SMB/WinXP/ServicePack");
 if(ereg(string:sp, pattern:"Service Pack [2-9]"))exit(0);
 key = "SOFTWARE\Microsoft\Updates\Windows XP\SP2\KB840315";
 item = "Description";
 value = registry_get_sz(item:item, key:key);
 if ( ! value ) security_hole(port);
 exit(0);
}

if ( "5.2" >< version )
{
 sp = get_kb_item("SMB/Win2003/ServicePack");
 if(ereg(string:sp, pattern:"Service Pack [1-9]"))exit(0);
 key = "SOFTWARE\Microsoft\Updates\Windows Server 2003\SP1\KB840315";
 item = "Description";
 value = registry_get_sz(item:item, key:key);
 if ( ! value ) security_hole(port);
 exit(0);
}
