#
# This script was originally written by Tenable Network Security and
# modified by George A. Theall, <theall@tifaware.com>.
#
# See the Nessus Scripts License for details.
#

if (description) {
  script_id(12228);
  script_version ("$Revision: 1.2 $");

  script_bugtraq_id(10246, 10439);
  script_cve_id("CAN-2004-0519", "CAN-2004-0520", "CAN-2004-0521");
  if (defined_func("script_xref")) {
    script_xref(name:"GLSA", value:"GLSA-200405-16:02");
    script_xref(name:"GLSA", value:"GLSA-200406-08");
    script_xref(name:"RHSA", value:"RHSA-2004:240-06");
  }
 
  name["english"] = "SquirrelMail XSS and Local escalation";
  script_name(english:name["english"]);
 
  desc["english"] = "
The remote host is running SquirrelMail, a web-based mail server.
 
There are several flaws in all versions less than 1.4.3 and development
versions 1.5.0 and 1.5.1 which allow for local root access and remote
Cross-Site-Scripting (XSS) attacks. 
 
Note : Nessus has determined the vulnerability exists on the target
simply by looking at the version number of Squirrelmail installed there;
it has not attempted to actually exploit the vulnerabilities. 

Solution : Upgrade to SquirrelMail 1.4.3 or greater
 
Risk Factor : Medium";
  script_description(english:desc["english"]);
 
  summary["english"] = "SquirrelMail XSS and Local escalation";
  script_summary(english:summary["english"]);
 
  script_category(ACT_GATHER_INFO);
  script_copyright(english:"This script is Copyright (C) 2004 George A. Theall and Tenable Network Security");

  family["english"] = "CGI abuses";
  script_family(english:family["english"]);

  script_dependencie("squirrelmail_detect.nasl");
  script_require_ports("services/www", 80);

  exit(0);
}

include("http_func.inc");

port = get_http_port(default:80);
if(!get_port_state(port)) exit(0);

vers = get_kb_item(string("www/", port, "/squirrelmail/version"));
if (!vers) exit(0);
if (ereg(pattern:"^(0|1\.(0|2|4\.[1-2]|4\.3\-RC1|5\.0|5\.1))$", string:vers)) security_hole(port);
